import javax.sound.sampled.*;
import java.io.*;
    class AUD {
    	Mixer mixer;
	SourceDataLine line;
	static int sr = 44100;
	static float floatSr = (float)44100;
	static int channels = 1;
	static int bits = 16;
	static int bufferSize = 4096*4;
	AudioFormat format = new AudioFormat(floatSr,bits,channels,true,false); 
        //AudioFormat format = new AudioFormat(AudioFormat.Encoding.PCM_SIGNED, floatSr, bits, channels, 2, floatSr, false); //2
 	AUD() {
		DataLine.Info info = new DataLine.Info(SourceDataLine.class, format); // format is an AudioFormat object
		if (!AudioSystem.isLineSupported(info)) {
			System.exit(0);
	    	}
		
	    // Obtain and open the line.
		try {
		    line = (SourceDataLine) AudioSystem.getLine(info);
	   	 bufferSize = (int) format.getSampleRate() * format.getFrameSize();
		    //line.open(format,bufferSize);
		    line.open(format);
	            line.start();
			
			
		} catch (LineUnavailableException ex) {
			System.out.println("WTF open error");
			System.exit(0);
		}
	}	
	void out_realtime(int [] b) {
		int length  = 2*b.length;
		if (length <= 0) {
			return ;
		}
		byte [] out = new byte[length]; 
		int tmp;
		for (int i = 0; i < b.length; i++) {
			tmp = b[i];
			tmp = tmp << 24;
			tmp = tmp >> 24;
			out[2*i+0]  = (byte)tmp;
		
			tmp = b[i];
			tmp = tmp << 16;
			tmp = tmp >> 24;
			out[2*i+1] = (byte)tmp;
		}
	}
	public void out_realtime(float [] data) {
		out_realtime(data,0,data.length);
	}
	public void out_realtime(float [] data,int start, int end) {
		try {
		int hi = 0;
		int low = 0;
		byte [] buffer = new byte[data.length*2];
		for (int i = start; i < end; i++) {
			hi = (int)data[i];
			//low = hi;
			//hi <<= 16;
			//hi >>= 24;
			//low <<= 24;
			//low >>= 24;
			//buffer[0+count] = (byte)low; 	
			//buffer[1+count] = (byte)hi; 	
			//buffer[1+2*i] = (byte)low; 	//little endian
			//buffer[0+2*i] = (byte)hi; 	
			buffer[2*i + 0] = (byte) (hi & 0xFF);
                        buffer[2*i + 1] = (byte) ((hi >>> 8) & 0xFF);
		}
		line.write(buffer,0,buffer.length);
		} catch (Exception e) {
			System.err.println(e + "WTF");
		}
		//fileOut.close();
	}
	public static void playAudioStream( AudioInputStream audioInputStream ) {
	  // Audio format provides information like sample
	  // rate, size, channels.
	  AudioFormat audioFormat =
	   audioInputStream.getFormat();
	  System.out.println("AudioPlayer.playAudioStream audio format: " + audioFormat );
	
	  // Open a data line to play our type of sampled
	  // audio. Use SourceDataLine for play and
	  // TargetDataLine for record.
	  DataLine.Info info = new DataLine.Info(
	   SourceDataLine.class, audioFormat );
	  if ( !AudioSystem.isLineSupported( info ) ) {
	   System.out.println("AudioPlayer.playAudioStream does not " + " handle this type of audio." );
	   return;
	  }
	
	  try {
	   // Create a SourceDataLine for play back
	   // (throws LineUnavailableException).  
	   SourceDataLine dataLine = (SourceDataLine)
	    AudioSystem.getLine( info );
	
	   // The line acquires system resources (throws
	   // LineAvailableException).
	   dataLine.open( audioFormat );
	
	   // Allows the line to move data in and out to
	   // a port.
	   dataLine.start();
	
	   // Create a buffer for moving data from the
	   // audio stream to the line.   
	   int bufferSize =
	   (int) audioFormat.getSampleRate() *
	   audioFormat.getFrameSize();
	   byte [] buffer = new byte[ bufferSize ];
	
	   // Move the data until done or there is an
	   // error.
	   try {
	    int bytesRead = 0;
	    while ( bytesRead >= 0 ) {
	    bytesRead = audioInputStream.read(
	    buffer, 0, buffer.length );
	    if ( bytesRead >= 0 ) 
	    dataLine.write( buffer, 0, bytesRead );
	    }
	   } catch ( IOException e ) {
	   e.printStackTrace();
	  }
	
	  // Continues data line I/O until its buffer is drained.
	  dataLine.drain();
	
	  // Closes the data line, freeing any resources such
	  // as the audio device.
	  dataLine.close();
	  } catch ( LineUnavailableException e ) {
	   e.printStackTrace();
	  }
	 } // playAudioStream
	void test() {
			int max_bytes = 22000;
			byte [] b = new byte [max_bytes];
			for (int i = 0; i < max_bytes; i++) {
				byte a = (byte)(i%127);
				a *= (byte)(1 - 2*((byte)i%2)); //1 or 1-2 = -1
				b[i] = a;
			}
			line.write(b,0,max_bytes);
	}
	void destroy() {
		try{
			line.drain();
			line.stop();
			line.close();
			line = null;
		} catch (Exception ex) {

		}
	}
	
	//	AudioInputStream in = AudioSystem.getAudioInputStream(AudioFormat Encoding.PCM_SIGNED);

    }
