import java.awt.*;
public class AudioThread extends Thread {
	float [] dataIN;
	float [] dataOUT;
	ImagePanel panel;
	AUD audio;
	int samples = 0;
	AudioThread(int samples,AUD audio,ImagePanel panel) {
		dataIN = new float[panel.getHeight()];
		dataOUT = new float[panel.getHeight()];
		this.audio = audio;
		this.samples = samples;
		this.panel = panel;
	}
	public void run() {
		int start = 0;
		int width = panel.getWidth();
		int height = panel.getHeight();
		int update = 0;
		int step = 50;
		int oldX = 0;
		while(true) {
			for (int x = 0; x < width; x++) {
				for (int y = 0; y < height; y++) {
					int [] rgb = panel.getRGBList(x,height - 1 - y);
					dataIN[y] = (32000*(rgb[0]+rgb[1]+rgb[2])/(255*3))/5.0f;
				}
				fft.cosinualfft(dataIN,dataOUT);
				audio.out_realtime(dataOUT);
				Graphics g = panel.getGraphics();
				update++;
				if (g!=null && (update % step == 0)) {
					g.setXORMode(Color.white);
					int val = (update - height) % width;
					int backval = (update - height - step) % width;
					g.drawLine(val,0,val,height-1);
					g.drawLine(backval,0,backval,height-1);
					g.setPaintMode();
				}
			}
		}
	}
}
