import java.awt.*;
public class FillBoxDrawTool extends DrawTool {
	boolean previous = false;
	int xor = 0;
	int oldX = 0;
	int oldY = 0;
	int xorX = -1;
	int xorY = -1;
	boolean invert = false;

	FillBoxDrawTool(PaintPanel paintPanel) {
		super(paintPanel);
	}
	FillBoxDrawTool(PaintPanel paintPanel,boolean inv) {
		super(paintPanel);
		invert = inv;
	}
	void actionPoint(int x, int y) {
		if (previous) {
			previous = false;
			drawRect(oldX,oldY,x,y);
			xorX = xorY = -1;
		} else {
			oldX = x;
			oldY = y;
			previous = true;
		}
	}
	void xorRect(int x1, int y1, int x2, int y2) {
		int minx = Math.min(x1,x2);
		int miny = Math.min(y1,y2);
		int width = Math.max(x1,x2) - minx;
		int height = Math.max(y1,y2) - miny;
		Graphics g2d = paintPanel.getGraphics();
		g2d.setXORMode(Color.white);
		g2d.fillRect(minx,miny,width,height);
		g2d.setPaintMode();
		paintPanel.needPaint();
	}
	void drawRect(int x1, int y1, int x2, int y2) {
		int minx = Math.min(x1,x2);
		int miny = Math.min(y1,y2);
		int maxx = Math.max(x1,x2);
		int maxy = Math.max(y1,y2);
		if (miny < 0) {
			miny = 0;
		}
		if (miny < 0) {
			miny = 0;
		}
		if (maxx > paintPanel.getWidth()) {
			maxx = paintPanel.getWidth() - 1;
		}
		if (maxy > paintPanel.getHeight()) {
			maxy = paintPanel.getHeight() - 1 ;
		}
		int width = maxx - minx;
		int height = maxy - miny;
		int color = 0;
		if (invert) {
			color = 254;
		}
		//Graphics g2d = paintPanel.getGraphics();
		//g2d.fillRect(minx,miny,width,height);
		for (int y = 0; y <= height; y++) {
			for (int x = 0; x <= width; x++) {
				if (paintPanel.withinBounds(x+minx,y+miny)) {
					paintPanel.setRGB(x+minx,y+miny,color,color,color);
				}
			}
		}
		paintPanel.needPaint();
	}
	void actionLine(int x1, int y1, int x2, int y2) {
		if (previous) {
			xor = ++xor % 2; // if xor is 1 we have to erase
			//draw xor rectangle from x2 y2 to oldX oldY
			//if xorX xorY erase it!
			if (xorX < 0) {
				xorRect(oldX,oldY,xorX,xorY);
			}
			xorRect(oldX,oldY,x2,y2);
			xorX = x2;
			xorY = y2;
		}
	}
	String getName() {
		if (invert) {
			return "White Fill";
		} else {
			return "Black Fill";
		}
	}
}
