import java.awt.*;
import java.awt.image.*;
import javax.swing.*;
    class ImagePanel extends JPanel {
        BufferedImage image;
        ImagePanel (int width,int height) {
                super();
                newImage(width,height);
                setAutoscrolls(true);
        }
        ImagePanel () {
                super();
                newImage(1,1);
                setAutoscrolls(true);
        }
        private void newImage(int width,int height) {
                image = new BufferedImage(width,height,BufferedImage.TYPE_INT_ARGB);
    	    	Graphics g2D = image.createGraphics();
		g2D.setColor(Color.white);
		g2D.fillRect(0,0,width,height);
		setPreferredSize(new Dimension(width,height));
		setSize(new Dimension(width,height));
        }
        public void paint(Graphics g) {
                g.drawImage(image,0,0,this);
        }
        void load_image(String file) {
                ImageIcon icon = new ImageIcon(file);
                newImage(icon.getIconWidth(),icon.getIconHeight());
                Graphics2D g2D = image.createGraphics();
                g2D.drawImage(icon.getImage(),0,0,this);
        }

        boolean withinBounds(int x,int y) {
                return (!(x < 0 || (y < 0) ||  (y >= image.getHeight()) || (x >= image.getWidth())));
        }
        int getRGB(int x,int y) {
               if (!withinBounds(x,y)) {
                   return -1;
                } 
                return image.getRGB(x,y);
        }
	int [] getRGBList(int x, int y) {
		int k = getRGB(x,y);	
		int [] out = new int [3];
		out[2] = (k & 0x000000FF);//Blue
		out[1] = ((k & 0x0000FF00) >> 8);
		out[0] = ((k & 0x00FF0000) >> 16);
		return out;	
	}
	
        int getRGB(double x,double y) {
                return getRGB(new Double(x).intValue(),new Double(y).intValue());
        }
        void setRGB(int x, int y, int red,int green, int blue) {
		green = green%255 << 8;	
		red = red%255 << 16;	
		blue = blue%255;	
		int alpha = 255 << 24;
		int k =red + blue + green + alpha;
		//int k = (red | green | blue  | 0 );

		image.setRGB(x,y,k); 
	}
	void drawLine(int xa,int ya,int xb,int yb) {
		drawLine(xa,ya,xb,yb,Color.red);	
	}
	void drawLine(int xa,int ya,int xb,int yb,Color color) {
		if (withinBounds(xa,ya) && withinBounds(xb,yb)) { 
    	    		Graphics g2D = image.createGraphics();
			g2D.setColor(color);
			g2D.drawLine(xa,ya,xb,yb);
		}
	}
	Image getImage() {
		return image;
	}
    }
