import javax.swing.*;
import java.io.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.util.*;

public class PaintWidget extends JPanel implements ActionListener,MouseMotionListener,MouseListener {
	PaintPanel paintPanel;
	ArrayList toolList;
	DrawTool currentTool;
	JPanel toolBox;
	PaintWidget(PaintPanel paintPanel) {
		super();
		this.paintPanel = paintPanel;
		add(paintPanel);
		toolList = new ArrayList();
		this.paintPanel.addMouseListener(this);
		this.paintPanel.addMouseMotionListener(this);
		this.toolBox = new JPanel();
		toolBox.setLayout(new BoxLayout(toolBox,BoxLayout.Y_AXIS));
		this.setLayout(new BoxLayout(this,BoxLayout.X_AXIS));
		
		add(toolBox);
	}
	void addTool(DrawTool t) {
		toolList.add(t);	
		if (currentTool == null) {
			currentTool = t;
		}
		BoundedButton b = new BoundedButton(t);
		b.addActionListener(this);
		toolBox.add((Component)b);
	}
	public void actionPerformed(ActionEvent e) {
		if ( e.getSource() instanceof BoundedButton ) {
			BoundedButton b = (BoundedButton)e.getSource();
			currentTool = b.getTool();
		}
	}
        //class PaintWidgetlListener implements MouseListener,MouseMotionListener {
		double oldX = -1;
		double oldY = -1;
		public void mouseDragged(MouseEvent e) {
			Point p = e.getPoint();
			double X = p.getX();
			double Y = p.getY();
			if (oldX < 0 || oldY  < 0 ) {
				oldX = X;
				oldY = Y;
			}
			PaintPanel self = (PaintPanel)e.getSource();
			int x = (int)X;
			int y = (int)Y;
			currentTool.actionLine((int)oldX,(int)oldY,(int)X,(int)Y);
			oldY = Y;
			oldX = X;
			self.needPaint();
		}
		public void mouseMoved(MouseEvent e) {
			Point p = e.getPoint();
			double X = p.getX();
			double Y = p.getY();
			PaintPanel self = (PaintPanel)e.getSource();
		 	self.setToolTipText("(" + X + "," + Y + ") - " + self.getRGB(X,Y));
		}
		public void mouseClicked(MouseEvent e) {
		}
		public void mouseEntered(MouseEvent e) {
		}
		public void mouseExited(MouseEvent e) {
		}
		public void mousePressed(MouseEvent e) {
			Point p = e.getPoint();
			double X = p.getX();
			double Y = p.getY();
			oldX = X;
			oldY = Y;
			PaintPanel self = (PaintPanel)e.getSource();
			//self.addRGB((int)X,(int)Y,30,30,30);
			currentTool.actionPoint((int)X,(int)Y);
			self.needPaint();
		}
		public void mouseReleased(MouseEvent e) {
			Point p = e.getPoint();
			double X = p.getX();
			double Y = p.getY();
			oldY = -1;
			oldX = -1;
			PaintPanel self = (PaintPanel)e.getSource();
			currentTool.actionPoint((int)X,(int)Y);
			self.needPaint();
		}
	//}
	
	

}
