import java.awt.image.*;
import java.awt.*;
import javax.sound.sampled.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.math.*;

public class drawer extends JPanel implements ActionListener {

    ScratchPanel scratchpanel; //Supposedly this can host a picture!
    LinkedList mainList; //This list holds lots of little lists
    LinkedList currentList;
    TextField text;
    TextField loopCountField;
    int loopCount = 0;
    JSlider audioLengthSlider;
    JSlider volumeSlider;
    AUD audio;

	static int sr = 44100;
	static float floatSr = (float)44100.0;
	static int channels = 1;
	static int bits 	= 16;
	Color ignoreColor = Color.white;
    
    public Dimension getPreferredSize() {
     Dimension size = super.getPreferredSize();
     size.width = 300;
     size.height = 300;
     return size;
   }
    public drawer() { //constructor
	setAutoscrolls(true);
	System.out.println("AUDIO INIT");
	audio = new AUD();
	System.out.println("AUDIO INIT DONE");
 	scratchpanel = new ScratchPanel();
 	//scratchpanel.load_image("sample.gif");
 	ScratchPanelListener s = new ScratchPanelListener(this);	
 	scratchpanel.addMouseMotionListener(s);
 	scratchpanel.addMouseListener(s);
	audioLengthSlider = new JSlider(JSlider.HORIZONTAL,1,100,10);
	volumeSlider = new JSlider(JSlider.HORIZONTAL,1,100,10);
	loopCountField = new TextField("0");
	text = new TextField("sample.gif");
	Button button = new Button("Load");
	Button playButton = new Button("Play");
	Button loopButton = new Button("Loop");
	Button resetButton = new Button("Reset");
	text.setEditable(true);
	button.addActionListener(this);
	playButton.addActionListener(this);
	resetButton.addActionListener(this);
	loopButton.addActionListener(this);
	//setLayout(new GridLayout(3,1));
	Panel panel = new Panel();
        panel.add(text);
        panel.add(button);
        panel.add(playButton);
        panel.add(resetButton);
        panel.add(loopButton);
        panel.add(loopCountField);
	panel.add(audioLengthSlider);
	panel.add(volumeSlider);
	add(panel);
        add(scratchpanel);
        setBorder(BorderFactory.createEmptyBorder(20,20,20,20));
	mainList = new LinkedList();
    }
    public int [] generate(int k,int length) {
	int height = scratchpanel.scratch.getHeight();
	int width = scratchpanel.scratch.getWidth();
	System.out.println("H: "+height+" W: "+width);
    	int [] gen = new int[width*length];
	int mid = height / 2;
	for (int x = 0; x < width; x++) {
		gen[x] = 0;
		for (int y = 0; y < height; y++) {
			if (ignoreColor.getRGB() != scratchpanel.scratch.getRGB(x,y)) {
				gen[length*x] += (y - mid);
			}
		}
		for (int i = 1; i<length; i++) {
			gen[length*x+i] = gen[length*x];
		}
		
	}
	for (int i = 1; i <length*width; i++) {
		gen[i] = (k*gen[i]);
	}
	return gen;	
    }
    public void loop() {
    	int k = new Integer(loopCountField.getText()).intValue();
	if (k > 0) {
		loopCount = k;
	}
	int length = audioLengthSlider.getValue();
	int volume = volumeSlider.getValue();
	int [] gen = generate(volume,length);
    	while (loopCount > 0) {
		loopCount--;
		audio.out_realtime(gen);
	}
	loopCountField.setText(""+loopCount);
    }
    public void play() {
	int length = audioLengthSlider.getValue();
	int volume = volumeSlider.getValue();
	int [] gen = generate(volume,length);
	audio.out_realtime(gen);
    }
    public void printIt() {
	int length = audioLengthSlider.getValue();
	int volume = volumeSlider.getValue();
	int [] gen = generate(volume,length);
	for (int i=0; i < gen.length; i++) {
		System.out.print(gen[i] + ":");
	}
	System.out.print("\n");
    }

    public void actionPerformed(ActionEvent e) {
    	if (e.getSource() instanceof ButtonWObj) {
		ButtonWObj k = (ButtonWObj)e.getSource();
	} else if (e.getSource() instanceof Button) {
		Button src = (Button) e.getSource();
		if (new String("Load").equalsIgnoreCase(src.getLabel())) {
			scratchpanel.load_image(text.getText());
		} else if (new String("Play").equalsIgnoreCase(src.getLabel())) {
			play();
		} else if (new String("Loop").equalsIgnoreCase(src.getLabel())) {
			loop();
		} else if (new String("Reset").equalsIgnoreCase(src.getLabel())) {
			this.reset();
		}
	}
    }
    void reset() {
    	scratchpanel.initScratch();
	scratchpanel.repaint();
    }


   class ButtonWObj extends Button {
	Object keep;
	ButtonWObj(String k) {
		super(k);
	}
	void associate(Object k) {
		keep = k;
	}
	Object getAssociation() {
		return keep;
	}
   }
    
    class ScratchPanel extends ImagePanel {
	BufferedImage scratch;
	Graphics g2D;
	ScratchPanel () {
		super(700,75);
		newImage(700,75);
	}
	ScratchPanel (int width,int height) {
		super(width,height);
		newImage(width,height);
	}
	private void newImage(int width,int height) {
		super.newImage(width,height);
		initScratch();
	}
	void load_image(String file) {
		super.load_image(file);
		initScratch();
	}
	
	void initScratch() {
		int width = image.getWidth();
		int height = image.getHeight();
		scratch = new BufferedImage(width,height,BufferedImage.TYPE_INT_ARGB);
    	    	g2D = scratch.createGraphics();
		g2D.setColor(Color.white);
		g2D.fillRect(0,0,width,height);
		g2D.drawImage(image,0,0,this);
		//drawLine(1,1,width-10,height-10);
		setPreferredSize(new Dimension(width,height));
		setSize(new Dimension(width,height));
	}
	void drawLine(double xa,double ya,double xb,double yb) {
		drawLine(new Double(xa).intValue(),new Double(ya).intValue(),
			 new Double(xb).intValue(),new Double(yb).intValue());
			
	}
	void drawLine(double xa,double ya,double xb,double yb,Color c) {
		drawLine(new Double(xa).intValue(),new Double(ya).intValue(),
			 new Double(xb).intValue(),new Double(yb).intValue(),c);

	}
	void drawLine(int xa,int ya,int xb,int yb) {
		drawLine(xa,ya,xb,yb,Color.red);	
	}
	void drawLine(int xa,int ya,int xb,int yb,Color color) {
		if (withinBounds(xa,ya) && withinBounds(xb,yb)) { 
    	    		g2D = scratch.createGraphics();
			g2D.setColor(color);
			//System.out.println("Draw Line" + xa + " " + ya + " " + xb + " " + " " + yb);
			g2D.drawLine(xa,ya,xb,yb);
		}
	}
	public void paint(Graphics g) {
		g.drawImage(scratch,0,0,this);
	}
	public void repaint(Graphics g) {
		paint(g);
	}

        
    }
    class ImagePanel extends JPanel {
	BufferedImage image;
	ImagePanel (int width,int height) {
		super();
		newImage(width,height);
		setAutoscrolls(true);
	}
	ImagePanel () {
		super();
		newImage(1,1);
		setAutoscrolls(true);
	}
	private void newImage(int width,int height) {
		image = new BufferedImage(width,height,BufferedImage.TYPE_INT_ARGB);
	}
	public void paint(Graphics g) {
		g.drawImage(image,0,0,this);
	}
	void load_image(String file) {
		ImageIcon icon = new ImageIcon(file);
		newImage(icon.getIconWidth(),icon.getIconHeight());
    	    	Graphics2D g2D = image.createGraphics();
		g2D.drawImage(icon.getImage(),0,0,this);
	}

    	void draw() {
    	    Graphics2D g2D = image.createGraphics();
    	    int maxY = image.getHeight();
    	    int maxX = image.getWidth();
    	    int step = 5;
    	    int count = 0;
    	    Color [] colors = new Color[2];
    	    colors[0] = Color.blue;
    	    colors[1] = Color.cyan;
    	    for (int y = maxY - 1; y >= 0; y -= step) {
    	    	for (int x = maxX - 1 ; x >= 0; x -= step) {
    	    		g2D.setColor(colors[count%2]);
    	    		count++;
    	    		g2D.fillRect(0,0,x,y);
    	    	}
    	    }
    	}
	boolean withinBounds(int x,int y) {
		return (!(x < 0 || (y < 0) ||  (y >= image.getHeight()) || (x >= image.getWidth())));
	}
	int getRGB(int x,int y) {
		if (!withinBounds(x,y)) {
			return -1;
		}
		return image.getRGB(x,y);
	}
	int getRGB(double x,double y) {
		return getRGB(new Double(x).intValue(),new Double(y).intValue());
	}
	
    }

    /** Listens to the check boxes. */
    class timedInt {
	long time;
	int val;
	timedInt() {
		time = System.currentTimeMillis();
		val = 0;
	}
	timedInt(long t,int k) {
		time = t;
		val = k;
	}
	String strout() {
		return ("[ AT: " + time + " VAL: " + val);
	}
    }
    class ImagePanelListener implements MouseListener,MouseMotionListener {
    	drawer app;
	ImagePanelListener () {
		app = null;
	}
	ImagePanelListener(drawer a) {
		app = a;
	}

    	public void mouseDragged(MouseEvent e) {
		Point p = e.getPoint();
		double X = p.getX();
		double Y = p.getY();
		ImagePanel self = (ImagePanel)e.getSource();
		if (app != null) {
		}	
		//System.out.println("Drag");
	}
	public void mouseMoved(MouseEvent e) {
		Point p = e.getPoint();
		double X = p.getX();
		double Y = p.getY();
		ImagePanel self = (ImagePanel)e.getSource();
         	self.setToolTipText("(" + X + "," + Y + ") - " + self.getRGB(X,Y));
	}
	public void mouseClicked(MouseEvent e) {
	}
	public void mouseEntered(MouseEvent e) {
	}
	public void mouseExited(MouseEvent e) {
	}
	public void mousePressed(MouseEvent e) {
		Point p = e.getPoint();
		double X = p.getX();
		double Y = p.getY();
		ImagePanel self = (ImagePanel)e.getSource();
		//System.out.println("Pressed");
	}
	public void mouseReleased(MouseEvent e) {
		Point p = e.getPoint();
		double X = p.getX();
		double Y = p.getY();
		ImagePanel self = (ImagePanel)e.getSource();
		//System.out.println("Released");
	}
    }
    class ScratchPanelListener extends ImagePanelListener {
    	double prevx = 0;
    	double prevy = 0;
	boolean drawon = false;
	ScratchPanelListener(drawer k) {
		super(k);
	}
	void scratch(MouseEvent e,double X,double Y) {
		if (drawon) {
			ScratchPanel s =(ScratchPanel)e.getSource();
			s.drawLine(prevx,prevy,X,Y);
			s.repaint();
		}
		
	}
    	public void mouseDragged(MouseEvent e) {
		Point p = e.getPoint();
		double X = p.getX();
		double Y = p.getY();
		super.mouseDragged(e);
		scratch(e,X,Y);
		prevx = X;
		prevy = Y;
	}
	public void mousePressed(MouseEvent e) {
		Point p = e.getPoint();
		double X = p.getX();
		double Y = p.getY();
		super.mousePressed(e);
		drawon = true;
		prevx = X;
		prevy = Y;
	}
	public void mouseReleased(MouseEvent e) {
		Point p = e.getPoint();
		double X = p.getX();
		double Y = p.getY();
		super.mousePressed(e);
		scratch(e,X,Y);
		drawon = false;
	}
    }

    public static void main(String s[]) {
         JFrame frame = new JFrame("WidgetDemo");
         frame.addWindowListener(new WindowAdapter() {
             public void windowClosing(WindowEvent e) {
                 System.exit(0);
             }
         });
 
         frame.setContentPane(new drawer());
         frame.pack();
         frame.setVisible(true);
    }

//=============================================================================//
//	Audio
//=============================================================================//
    static class AUD {
    	Mixer mixer;
	SourceDataLine line;
	AudioFormat format = new AudioFormat(drawer.floatSr,drawer.bits,drawer.channels,true,false); //8bit audio!
 	AUD() {
   		Mixer.Info [] infos =  AudioSystem.getMixerInfo();
		for (int i = 0; i < infos.length; i++) {
			System.out.println("Mixer: " + infos[i].toString() );
		}
		int mixers = 0;
		mixer = AudioSystem.getMixer(infos[mixers]);
		DataLine.Info info = new DataLine.Info(SourceDataLine.class, format); // format is an AudioFormat object
		if (!mixer.isLineSupported(info)) {
			System.out.println("Not Supported "+ infos[mixers].toString()+ " "+ info.toString());
			System.exit(0);
	    	}
		Line.Info[] lineinfos =  mixer.getSourceLineInfo();
		for (int i = 0; i < lineinfos.length; i++) {
			System.out.println("Line: " + lineinfos[i].toString() );
		}
		int src_line = 0;
		
	    // Obtain and open the line.
		try {
		    line = (SourceDataLine) mixer.getLine(lineinfos[src_line]);
		    line.open(format,8096*2);
	            line.start();
		    test();
			
			
		} catch (LineUnavailableException ex) {
			System.out.println("WTF open error");
			System.exit(0);
		}
	}	
	void out_realtime(int [] b) {
		int length  = 2*b.length;
		if (length <= 0) {
			return ;
		}
		byte [] out = new byte[length]; 
		int tmp;
		for (int i = 0; i < b.length; i++) {
			tmp = b[i];
			tmp = tmp << 24;
			tmp = tmp >> 24;
			out[2*i+0]  = (byte)tmp;
		
			tmp = b[i];
			tmp = tmp << 16;
			tmp = tmp >> 24;
			out[2*i+1] = (byte)tmp;
		}
		line.write(out,0,length);
	}
	void test() {
			int max_bytes = 22000;
			byte [] b = new byte [max_bytes];
			for (int i = 0; i < max_bytes; i++) {
				byte a = (byte)(i%127);
				a *= (byte)(1 - 2*((byte)i%2)); //1 or 1-2 = -1
				b[i] = a;
			}
			line.write(b,0,max_bytes);
	}
	void destroy() {
		try{
			line.drain();
			line.stop();
			line.close();
			line = null;
		} catch (Exception ex) {

		}
	}
	
	//	AudioInputStream in = AudioSystem.getAudioInputStream(AudioFormat Encoding.PCM_SIGNED);

    }
}

