import java.awt.image.*;
import java.awt.*;
import javax.sound.sampled.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.math.*;

public class widget extends JPanel implements ActionListener {

    ScratchPanel scratchpanel; //Supposedly this can host a picture!
    LinkedList mainList; //This list holds lots of little lists
    LinkedList currentList;
    TextField text;
    AUD audio;
    Plug plugger;
    long startTime;

	static int sr = 44100;
	static float floatSr = (float)44100.0;
	static int channels = 1;
	static int bits 	= 16;
    
    public Dimension getPreferredSize() {
     Dimension size = super.getPreferredSize();
     size.width = 300;
     size.height = 300;
     return size;
   }
    public widget() { //constructor
	setAutoscrolls(true);
	System.out.println("AUDIO INIT");
	audio = new AUD();
	System.out.println("AUDIO INIT DONE");
	plugger = new Plug200Hz(); // We could always override this :)
 	scratchpanel = new ScratchPanel();
 	scratchpanel.load_image("sample.gif");
 	ScratchPanelListener s = new ScratchPanelListener(this);	
 	scratchpanel.addMouseMotionListener(s);
 	scratchpanel.addMouseListener(s);
	text = new TextField("sample.gif");
	Button button = new Button("Load");
	Button playButton = new Button("Play");
	Button resetButton = new Button("Reset");
	text.setEditable(true);
	button.addActionListener(this);
	playButton.addActionListener(this);
	resetButton.addActionListener(this);
	//setLayout(new GridLayout(3,1));
	Panel panel = new Panel();
        panel.add(text);
        panel.add(button);
        panel.add(playButton);
        panel.add(resetButton);
	JPanel brushPanel = new JPanel();
	brushPanel.setLayout(new GridLayout(2,3));
	ButtonWObj normal = new ButtonWObj("Normal");
	normal.addActionListener(this);
	normal.associate(plugger);
	ButtonWObj a200hz = new ButtonWObj("200Hz");
	a200hz.associate(new Plug200Hz());
	a200hz.addActionListener(this);
	ButtonWObj snoise = new ButtonWObj("SineNoiseVol");
	snoise.associate(new NoiseVolPlug());
	snoise.addActionListener(this);
	ButtonWObj noise = new ButtonWObj("Noise");
	noise.associate(new PureNoise());
	noise.addActionListener(this);
	ButtonWObj chorus = new ButtonWObj("Chorus");
	chorus.associate(new ChorusPlug());
	chorus.addActionListener(this);
        brushPanel.add(normal);
        brushPanel.add(a200hz);
        brushPanel.add(snoise);
        brushPanel.add(noise);
        brushPanel.add(chorus);
	add(panel);
	add(brushPanel);
        add(scratchpanel);
        setBorder(BorderFactory.createEmptyBorder(20,20,20,20));
	mainList = new LinkedList();
	startTime = System.currentTimeMillis();
    }

    public void actionPerformed(ActionEvent e) {
    	if (e.getSource() instanceof ButtonWObj) {
		ButtonWObj k = (ButtonWObj)e.getSource();
		plugger = (Plug) k.getAssociation();
	} else if (e.getSource() instanceof Button) {
		Button src = (Button) e.getSource();
		if (new String("Load").equalsIgnoreCase(src.getLabel())) {
			scratchpanel.load_image(text.getText());
		} else if (new String("Play").equalsIgnoreCase(src.getLabel())) {
			this.playSong();
		} else if (new String("Reset").equalsIgnoreCase(src.getLabel())) {
			this.reset();
		}
	}
    }
    void reset() {
	mainList = new LinkedList();
	currentList = null;
	startTime = System.currentTimeMillis();
    }

    void printTIList (LinkedList list) {
	ListIterator subiter = list.listIterator(0);
	timedPoint tp;
	while(subiter.hasNext()) {
		tp = (timedPoint) subiter.next();
		System.out.print(tp.strout() + "\t");
	}

    }
    void printMain() {
	ListIterator mainiter = mainList.listIterator(0);
	long t = 0;
	LinkedList   list;
	while(mainiter.hasNext()) {
		System.out.println("Entry " + t);
		list = (LinkedList) mainiter.next();
		printTIList(list);
	}
    }
    void addPoint(double X,double Y) {
	timedPoint newpoint = new timedPoint(System.currentTimeMillis() - startTime,X,Y);
	timedPoint tp;
	if (currentList == null) {
		currentList = new LinkedList();
	}
	if (currentList.size() >= 1) {
		tp = (timedPoint)currentList.getLast();
	} else {
		tp = newpoint;
	}
	currentList.add(newpoint);
	int [] buffer = gen(tp,newpoint);
	audio.out_realtime(buffer);
    }		
    void playSong() {
	ListIterator mainiter = this.mainList.listIterator(0);
	ListIterator miniter;
	long t = 0;
	LinkedList   list;
	long starting = System.currentTimeMillis();
	timedPoint current;
	timedPoint older = null;
	System.out.println("Play Song");
//	printMain();
	
	while(mainiter.hasNext()) {
		list = (LinkedList) mainiter.next();
		System.out.println("Main Iter Next");
		miniter = list.listIterator(0);
		while(miniter.hasNext()) {
			long currTime;
			current = (timedPoint)miniter.next();
			if (older == null) {
				older = current;
			}


			long waitTime = older.getTime();
			int [] buffer = gen(current,older);
			scratchpanel.drawLine(current.getX(),current.getY(),older.getX(),older.getY(),Color.green);
			scratchpanel.repaint();
			do {
				currTime = System.currentTimeMillis() - starting;
			} while (currTime < waitTime);
			audio.out_realtime(buffer);
			older = current;
		}
		older = null;
		
	}
	System.out.println("DONE");
	
    }
   int [] gen(timedPoint start, timedPoint end) { //probably wrong spot for timed stuff...
   	long startTime = start.getTime();
   	long endTime = end.getTime();
   	if (startTime > endTime) { //swap
   		timedPoint tmp = start;
   		start = end;
   		end = tmp;
   		startTime = start.getTime();
   		endTime = end.getTime();
   	}
   	double sx = start.getX();
   	double sy = start.getY();
   	double dy = end.getY() - start.getY();
   	double dx = end.getX() - start.getX();
   	int time = (int)(endTime - startTime);
   	double dtime = new Integer(time).doubleValue();
   //	double xincTime = dx/dtime; 
   //	double TimeXPerPixel = dtime/dx; 
   //	double TimeYPerPixel = dtime/dy; //30secs / 10 pixels = 3secs per pixel X 
   //	double yincTime = dy/dtime;
   	double slope = dy/dx;
   	double length = Math.sqrt(dx*dx+dy*dy);
	int ilength = new Double(length).intValue();
   	int timePerPixel = new Double(dtime/length).intValue();
   	double x;
   	double y;
   	int samples = new Double(Math.ceil((widget.sr*timePerPixel)/1000.0)).intValue();
	if (samples == 0) {
		return new int [0];
	}
   	int [] buffer = new int [(samples+1)*ilength];
   	int offset = 0;
	int val;
   	for (int i = 0; i < time; i+= timePerPixel) {
   		double di = new Integer(i).doubleValue();
   		x = dx * (i / dtime) + sx;
   		y = dy * (i / dtime) + sy;
   	    	val = scratchpanel.getRGB(x,y); //Supposedly this can host a picture!		
   		plugger.render(samples,val,buffer,offset);
   		offset += samples;
   	}
	return buffer;
   }

   class ButtonWObj extends Button {
	Object keep;
	ButtonWObj(String k) {
		super(k);
	}
	void associate(Object k) {
		keep = k;
	}
	Object getAssociation() {
		return keep;
	}
   }
    
    class ScratchPanel extends ImagePanel {
	BufferedImage scratch;
	Graphics g2D;
	private void newImage(int width,int height) {
		super.newImage(width,height);
		initScratch();
	}
	void load_image(String file) {
		super.load_image(file);
		initScratch();
	}
	
	void initScratch() {
		int width = image.getWidth();
		int height = image.getHeight();
		scratch = new BufferedImage(width,height,BufferedImage.TYPE_INT_ARGB);
    	    	g2D = scratch.createGraphics();
		g2D.drawImage(image,0,0,this);
		//drawLine(1,1,width-10,height-10);
		setPreferredSize(new Dimension(width,height));
		setSize(new Dimension(width,height));
	}
	void drawLine(double xa,double ya,double xb,double yb) {
		drawLine(new Double(xa).intValue(),new Double(ya).intValue(),
			 new Double(xb).intValue(),new Double(yb).intValue());
			
	}
	void drawLine(double xa,double ya,double xb,double yb,Color c) {
		drawLine(new Double(xa).intValue(),new Double(ya).intValue(),
			 new Double(xb).intValue(),new Double(yb).intValue(),c);

	}
	void drawLine(int xa,int ya,int xb,int yb) {
		drawLine(xa,ya,xb,yb,Color.red);	
	}
	void drawLine(int xa,int ya,int xb,int yb,Color color) {
		if (withinBounds(xa,ya) && withinBounds(xb,yb)) { 
    	    		g2D = scratch.createGraphics();
			g2D.setColor(color);
			//System.out.println("Draw Line" + xa + " " + ya + " " + xb + " " + " " + yb);
			g2D.drawLine(xa,ya,xb,yb);
		}
	}
	public void paint(Graphics g) {
		g.drawImage(scratch,0,0,this);
	}
	public void repaint(Graphics g) {
		paint(g);
	}

        
    }
    class ImagePanel extends JPanel {
	BufferedImage image;
	ImagePanel (int width,int height) {
		super();
		newImage(width,height);
		setAutoscrolls(true);
	}
	ImagePanel () {
		super();
		newImage(1,1);
		setAutoscrolls(true);
	}
	private void newImage(int width,int height) {
		image = new BufferedImage(width,height,BufferedImage.TYPE_INT_ARGB);
	}
	public void paint(Graphics g) {
		g.drawImage(image,0,0,this);
	}
	void load_image(String file) {
		ImageIcon icon = new ImageIcon(file);
		newImage(icon.getIconWidth(),icon.getIconHeight());
    	    	Graphics2D g2D = image.createGraphics();
		g2D.drawImage(icon.getImage(),0,0,this);
	}

    	void draw() {
    	    Graphics2D g2D = image.createGraphics();
    	    int maxY = image.getHeight();
    	    int maxX = image.getWidth();
    	    int step = 5;
    	    int count = 0;
    	    Color [] colors = new Color[2];
    	    colors[0] = Color.blue;
    	    colors[1] = Color.cyan;
    	    for (int y = maxY - 1; y >= 0; y -= step) {
    	    	for (int x = maxX - 1 ; x >= 0; x -= step) {
    	    		g2D.setColor(colors[count%2]);
    	    		count++;
    	    		g2D.fillRect(0,0,x,y);
    	    	}
    	    }
    	}
	boolean withinBounds(int x,int y) {
		return (!(x < 0 || (y < 0) ||  (y >= image.getHeight()) || (x >= image.getWidth())));
	}
	int getRGB(int x,int y) {
		if (!withinBounds(x,y)) {
			return -1;
		}
		return image.getRGB(x,y);
	}
	int getRGB(double x,double y) {
		return getRGB(new Double(x).intValue(),new Double(y).intValue());
	}
	
    }

    /** Listens to the check boxes. */
    class timedInt {
	long time;
	int val;
	timedInt() {
		time = System.currentTimeMillis();
		val = 0;
	}
	timedInt(long t,int k) {
		time = t;
		val = k;
	}
	String strout() {
		return ("[ AT: " + time + " VAL: " + val);
	}
    }
    class timedPoint {
    	long time;
	Point pnt;	
	timedPoint() {
		time = System.currentTimeMillis();
		pnt = new Point();
		pnt.setLocation(0.0,0.0);
	}
	timedPoint(Point k) {
		time = System.currentTimeMillis();
		pnt = k;
	}
	timedPoint(long t,Point k) {
		time = t;
		pnt = k;
	}
	timedPoint(long t,double x,double y) {
		time = t;
		pnt = new Point();
		pnt.setLocation(x,y);
		
	}
	long getTime() {
		return time;
	}
	Point getPoint() {
		return pnt;
	}
	double getX() { //doubles?
		return pnt.getX();
	}
	double getY() {
		return pnt.getY();
	}	
	String strout() {
		double X = pnt.getX();
		double Y = pnt.getX();
		return ("[ AT: " + time + "(" + X + "," + Y + ") ]");
	}
    }
    class ImagePanelListener implements MouseListener,MouseMotionListener {
    	widget app;
	ImagePanelListener () {
		app = null;
	}
	ImagePanelListener(widget a) {
		app = a;
	}

    	public void mouseDragged(MouseEvent e) {
		Point p = e.getPoint();
		double X = p.getX();
		double Y = p.getY();
		ImagePanel self = (ImagePanel)e.getSource();
		if (app != null) {
			app.addPoint(X,Y);
			app.currentList.add(new timedPoint(System.currentTimeMillis() - app.startTime,X,Y));
		}	
		//System.out.println("Drag");
	}
	public void mouseMoved(MouseEvent e) {
		Point p = e.getPoint();
		double X = p.getX();
		double Y = p.getY();
		ImagePanel self = (ImagePanel)e.getSource();
         	self.setToolTipText("(" + X + "," + Y + ") - " + self.getRGB(X,Y));
	}
	public void mouseClicked(MouseEvent e) {
	}
	public void mouseEntered(MouseEvent e) {
	}
	public void mouseExited(MouseEvent e) {
	}
	public void mousePressed(MouseEvent e) {
		Point p = e.getPoint();
		double X = p.getX();
		double Y = p.getY();
		ImagePanel self = (ImagePanel)e.getSource();
		if (app != null) {
			app.currentList = new LinkedList();
			app.mainList.add(app.currentList);
			app.currentList.add(new timedPoint(System.currentTimeMillis() - app.startTime,X,Y));
		}
		//System.out.println("Pressed");
	}
	public void mouseReleased(MouseEvent e) {
		Point p = e.getPoint();
		double X = p.getX();
		double Y = p.getY();
		ImagePanel self = (ImagePanel)e.getSource();
		if (app != null) {
				app.printTIList(app.currentList);
				app.currentList = null;
		}
		//System.out.println("Released");
	}
    }
    class ScratchPanelListener extends ImagePanelListener {
    	double prevx = 0;
    	double prevy = 0;
	boolean drawon = false;
	ScratchPanelListener(widget k) {
		super(k);
	}
	void scratch(MouseEvent e,double X,double Y) {
		if (drawon) {
			ScratchPanel s =(ScratchPanel)e.getSource();
			s.drawLine(prevx,prevy,X,Y);
			s.repaint();
		}
		
	}
    	public void mouseDragged(MouseEvent e) {
		Point p = e.getPoint();
		double X = p.getX();
		double Y = p.getY();
		super.mouseDragged(e);
		scratch(e,X,Y);
		prevx = X;
		prevy = Y;
	}
	public void mousePressed(MouseEvent e) {
		Point p = e.getPoint();
		double X = p.getX();
		double Y = p.getY();
		super.mousePressed(e);
		drawon = true;
		prevx = X;
		prevy = Y;
	}
	public void mouseReleased(MouseEvent e) {
		Point p = e.getPoint();
		double X = p.getX();
		double Y = p.getY();
		super.mousePressed(e);
		scratch(e,X,Y);
		drawon = false;
	}
    }

    public static void main(String s[]) {
         JFrame frame = new JFrame("WidgetDemo");
         frame.addWindowListener(new WindowAdapter() {
             public void windowClosing(WindowEvent e) {
                 System.exit(0);
             }
         });
 
         frame.setContentPane(new widget());
         frame.pack();
         frame.setVisible(true);
    }

//=============================================================================//
//	Audio
//=============================================================================//
    static class AUD {
    	Mixer mixer;
	SourceDataLine line;
	AudioFormat format = new AudioFormat(widget.floatSr,widget.bits,widget.channels,true,false); //8bit audio!
 	AUD() {
   		Mixer.Info [] infos =  AudioSystem.getMixerInfo();
		for (int i = 0; i < infos.length; i++) {
			System.out.println("Mixer: " + infos[i].toString() );
		}
		int mixers = 0;
		mixer = AudioSystem.getMixer(infos[mixers]);
		DataLine.Info info = new DataLine.Info(SourceDataLine.class, format); // format is an AudioFormat object
		if (!mixer.isLineSupported(info)) {
			System.out.println("Not Supported "+ infos[mixers].toString()+ " "+ info.toString());
			System.exit(0);
	    	}
		Line.Info[] lineinfos =  mixer.getSourceLineInfo();
		for (int i = 0; i < lineinfos.length; i++) {
			System.out.println("Line: " + lineinfos[i].toString() );
		}
		int src_line = 0;
		
	    // Obtain and open the line.
		try {
		    line = (SourceDataLine) mixer.getLine(lineinfos[src_line]);
		    line.open(format,8096*2);
	            line.start();
		    test();
			
			
		} catch (LineUnavailableException ex) {
			System.out.println("WTF open error");
			System.exit(0);
		}
	}	
	void out_realtime(int [] b) {
		int length  = 2*b.length;
		if (length <= 0) {
			return ;
		}
		byte [] out = new byte[length]; 
		int tmp;
		for (int i = 0; i < b.length; i++) {
			tmp = b[i];
			tmp = tmp << 24;
			tmp = tmp >> 24;
			out[2*i+0]  = (byte)tmp;
		
			tmp = b[i];
			tmp = tmp << 16;
			tmp = tmp >> 24;
			out[2*i+1] = (byte)tmp;
		}
		line.write(out,0,length);
	}
	void test() {
			int max_bytes = 22000;
			byte [] b = new byte [max_bytes];
			for (int i = 0; i < max_bytes; i++) {
				byte a = (byte)(i%127);
				a *= (byte)(1 - 2*((byte)i%2)); //1 or 1-2 = -1
				b[i] = a;
			}
			line.write(b,0,max_bytes);
	}
	void destroy() {
		try{
			line.drain();
			line.stop();
			line.close();
			line = null;
		} catch (Exception ex) {

		}
	}
	
	//	AudioInputStream in = AudioSystem.getAudioInputStream(AudioFormat Encoding.PCM_SIGNED);

    }
//=============================================================================//
//	Plugins: Plug Template
//=============================================================================//
class Plug {
	int [] sine;
	int [] square;
	int [] saw;
	int count = 4096;
	int max = 32677;
	double dcount = new Integer(count).doubleValue();
	Plug() {
		init_tables();
	}
	void init_tables() {
		if (sine==null) {
			sine = new int [count];
			for (int i = 0; i <  count; i++) {
				sine[i] = max*(new Double(Math.sin((i*Math.PI)/(dcount))).intValue());
			}
		}
		if (saw==null) {
			saw = new int [count];
			int count4 = count/4;
			int dy = max/(count4);
			int pos = 0;
			for (int i = 0; i <  count4; i++) {
				pos = pos - dy;	
				saw[i] = pos;
			}
			for (int i = count4; i <  count4*3; i++) {
				pos = pos + dy;	
				saw[i] = pos;
			}
			for (int i = count4*3; i <  count; i++) {
				pos = pos - dy;	
				saw[i] = pos;
			}
		}
		if (square == null) {
			square = new int [count];
			int count4 = count/4;
			for (int i = 0; i <  count4; i++) {
				square[i] = max/2;
			}
			for (int i = count4; i <  count4*3; i++) {
				square[i] = -max/2;
			}
			for (int i = count4*3; i <  count; i++) {
				square[i] = max/2;
			}
		}
	}
	int minHz = 10;
	int maxHz = 1100;
	int totalHz = maxHz - minHz;
	int [] getRGB(int val) {
		int [] output = new int [3];
		output[0]  = val << 8;
		output[1] = val << 16;
		output[2] = val << 24;
		for (int i = 0; i <  3; i++) {
			output[i] = output[i] >> 24;
			if (output[i] < 0) {
				output[i] = 127 - output[i]; //127 + - -output[i]
			}
		}
		return output;
	}
   	void render(int samples,int val,int [] buffer,int offset) {
		//example
		//Basically the 1st 3 bytes of the val are:
		//Sin Saw Sqr
		if (samples <= 0) {
			System.out.println("No Samples??");
		}
		int [] output = getRGB(val);
		for (int i = 0; i < 3; i++) {
			output[i] = (output[i] * totalHz / 255) + minHz;
		}
		int sinehz = output[0];
		int sawhz = output[1];
		int sqrhz = output[2];

		//System.out.println("Sine: " + sinehz + " Square: " + sqrhz + " Saw: " + sawhz);
		//Sine
		int sineSamplesPerHz = (widget.sr*samples/(sinehz*1000));
		int sqrSamplesPerHz  = (widget.sr*samples/(sqrhz *1000));
		int sawSamplesPerHz  = (widget.sr*samples/(sawhz *1000));
		fromTable(samples,sineSamplesPerHz,offset,sine,buffer,3);
		fromTable(samples,sqrSamplesPerHz,offset,square,buffer,3);
		fromTable(samples,sawSamplesPerHz,offset,saw,buffer,3);
	}

	void fromTable(int samples, int SamplesPerHz, int offset, int [] table, int [] buffer, int divisor) {
		for (int i = 0; i < samples; i += SamplesPerHz) {
			for (int k = 0; k < SamplesPerHz && (k + offset + i) < samples ; k++) {
				buffer[offset+i+k] += table[(count*k)/SamplesPerHz] / divisor;
			}
		}

	}
	void fromTable(int samples, int SamplesPerHz, int offset, int [] table, int [] buffer, double multiplier) {
		for (int i = 0; i < samples; i += SamplesPerHz) {
			for (int k = 0; k < SamplesPerHz && (k + offset + i) < samples ; k++) {
				buffer[offset+i+k] += new Double(table[(count*k)/SamplesPerHz] * multiplier).intValue();
			}
		}

	}
}

//=============================================================================//
//	Plugins
//=============================================================================//
	class Plug200Hz extends Plug {
	   	void render(int samples,int val,int [] buffer,int offset) {
			//example
			//Basically the 1st 3 bytes of the val are:
			//Sin Saw Sqr
			if (samples <= 0) {
				System.out.println("No Samples??");
			}
			int [] output = getRGB(val);
			for (int i = 0; i < 3; i++) {
				output[i] = (output[i] * totalHz / 255) + minHz;
			}
			double sineVol = output[0] / 255.0 / 3;
			double sawVol = output[1] / 255.0 / 3;
			double sqrVol = output[2] / 255.0 / 3;
			int sinehz = 200;
			int sawhz = 200;
			int sqrhz = 200;
	
			//System.out.println("Plug200Hz: Sine: " + sinehz + " Square: " + sqrhz + " Saw: " + sawhz);
			//Sine
			int sineSamplesPerHz = (widget.sr*samples/(sinehz*1000));
			int sqrSamplesPerHz  = (widget.sr*samples/(sqrhz *1000));
			int sawSamplesPerHz  = (widget.sr*samples/(sawhz *1000));
			fromTable(samples,sineSamplesPerHz,offset,sine,buffer,sineVol);
			fromTable(samples,sqrSamplesPerHz,offset,square,buffer,sqrVol);
			fromTable(samples,sawSamplesPerHz,offset,saw,buffer,sawVol);
		}
	
	}
	class NoiseVolPlug extends Plug {
	   	void render(int samples,int val,int [] buffer,int offset) {
			//example
			//Basically the 1st 3 bytes of the val are:
			//Sin Saw Sqr
			if (samples <= 0) {
				System.out.println("No Samples??");
			}
			int [] output = getRGB(val);
			for (int i = 0; i < 3; i++) {
				output[i] = (output[i] * totalHz / 255) + minHz;
			}
			int sinehz = output[0];
			int noiseRange = output[1];	
			double sineVol = output[2] / 255.0;
	
			//Sine
			//System.out.println("PlugNoiseVol: Sine: " + sinehz + " Noise: " + noiseRange + " Volume: " + sineVol);
			int sineSamplesPerHz = (widget.sr*samples/(sinehz*1000));
			fromTable(samples,sineSamplesPerHz,offset,sine,buffer,sineVol,noiseRange);
		}
		void fromTable(int samples, int SamplesPerHz, int offset, int [] table, int [] buffer, double multiplier,int noise) {
			for (int i = 0; i < samples; i += SamplesPerHz) {
				for (int k = 0; k < SamplesPerHz && (k + offset + i) < samples ; k++) {
					buffer[offset+i+k] += new Double(table[(count*k)/SamplesPerHz] * multiplier).intValue() + (new Double(noise*Math.random()).intValue() - noise/2);
				}
			}

		}
	
	}
	class PureNoise extends Plug {
	   	void render(int samples,int val,int [] buffer,int offset) {
			if (samples <= 0) {
				System.out.println("No Samples??");
			}
			int [] output = getRGB(val);
			int noiseRange = (output[0]+1)*(output[1]+1)*(output[2]+1) / 3;	
			while (noiseRange > max) {
				noiseRange = noiseRange / 2;
			}
			//System.out.println("Noise:  Noise: " + noiseRange);
			//fromTable(samples,1,offset,sine,buffer,1.0,noiseRange);
			for (int i = offset; i < buffer.length; i++) {
				buffer[i] += (new Double(noiseRange*Math.random()).intValue() - noiseRange/2);
			}
		}
		void fromTable(int samples, int SamplesPerHz, int offset, int [] table, int [] buffer, double multiplier,int noise) {
			for (int i = 0; i < samples; i += SamplesPerHz) {
				for (int k = 0; k < SamplesPerHz && (k + offset + i) < samples ; k++) {
					buffer[offset+i+k] += (new Double(noise*Math.random()).intValue() - noise/2);
				}
			}

		}
	}
	class ChorusPlug extends Plug {
	   	void render(int samples,int val,int [] buffer,int offset) {
			//example
			//Basically the 1st 3 bytes of the val are:
			//Sin Saw Sqr
			if (samples <= 0) {
				//System.out.println("No Samples??");
				return;
			}
			int [] output = getRGB(val);
			for (int i = 0; i < 3; i++) {
				output[i] = (output[i] * totalHz / 255) + minHz;
				int samplesPerHz = (widget.sr*samples/(output[i]*1000));
				fromTable(samples,samplesPerHz,offset,sine,buffer,1.333);
			}
	
		}
	
	}
}

